/*****
*
* tview.cpp
*
*****/ 

/*** include ***/
#include "tview.h"
#include "const.h"

tview::tview(BRect rect, char *name)
	   	   : BView(rect, name, B_FOLLOW_ALL, B_WILL_DRAW){
	reset_game();
	};

void tview::reset_game(){
	squares[0][0] = 0;	squares[1][0] = 0;	squares[2][0] = 0;
	squares[0][1] = 0;	squares[1][1] = 0;	squares[2][1] = 0;
	squares[0][2] = 0;	squares[1][2] = 0;	squares[2][2] = 0;
	player_turn = 1;
	game_over = 0;
	};
	
void tview::AttachedToWindow(){
	//SetFontName("Times New Roman");
	//SetFontSize(24);
	
	//SetFontName("Kate"); 
	SetFontSize(10);
	};


void tview::Draw(BRect){
	BRect frame;
	rgb_color tempColor;
	
	// Set Colors (grid color)
	tempColor.red 	= (uchar)100;
	tempColor.green = (uchar)100;
	tempColor.blue 	= (uchar)100;
	tempColor.alpha = (uchar)100;
	
	// (inner square color)
	SetHighColor(230,230,230);
	
	// Draw Frame
	frame.Set(3,22, WIDTH-3, HEIGHT-3);
	FillRect(frame);
	
	//Draw Grid
	SetPenSize(2.0);
	BeginLineArray(4);
	AddLine(BPoint((WIDTH*1/3)-1, 20), BPoint((WIDTH*1/3)-1, HEIGHT),tempColor);
	AddLine(BPoint((WIDTH*2/3)-1, 20), BPoint((WIDTH*2/3)-1, HEIGHT),tempColor);
	
	AddLine(BPoint(0,((HEIGHT-19)*1/3)+19), BPoint(WIDTH, ((HEIGHT-19)*1/3)+19),tempColor);
	AddLine(BPoint(0,((HEIGHT-19)*2/3)+20), BPoint(WIDTH, ((HEIGHT-19)*2/3)+20),tempColor);
	EndLineArray();
	
	// Begin the draw player icons
	
	// (player icon color)
	SetPenSize(1.0);
	
	short xs, xw, ys, yw;
	xs = (WIDTH*1/6); 				xw = (WIDTH*2/6);
	ys = ((HEIGHT-19)*1/6)+20; 		yw = ((HEIGHT-19)*1/6)+20;
	
	for (int i=0;i<3;i++)
		for (int j=0;j<3;j++)
			if (squares[i][j] == 1){
				SetHighColor(250, 30, 30);
				FillArc(BPoint(xs + xw*i, ys + yw*j), 10, 10, 0, 360);
				SetHighColor(230,230,230);
				FillArc(BPoint(xs + xw*i, ys + yw*j), 5, 5, 0, 360);
				}
			else if (squares[i][j] == 2){
				tempColor.red 	= (uchar)30;
				tempColor.green = (uchar)30;
				tempColor.blue 	= (uchar)250;
				tempColor.alpha = (uchar)150;
				SetPenSize(4.0);
				BeginLineArray(2);
				AddLine(BPoint((xs + xw*i)-8, (ys + yw*j)-8), 
					BPoint((xs + xw*i)+8, (ys + yw*j)+8), tempColor);
				AddLine(BPoint((xs + xw*i)+8, (ys + yw*j)-8), 
					BPoint((xs + xw*i)-8, (ys + yw*j)+8), tempColor);
				EndLineArray();
				};
	}; // End of draw
	
/*****
*  move
*****/
void tview::MouseDown(BPoint point){
	if (!game_over){

	if (point.x < (WIDTH*1/3)-2){				// Left Side of the Board
		if ((point.y < ((HEIGHT-19)*1/3)+19) && (!squares[0][0]))		// Top Left Square
			squares[0][0] = player_turn++;
		else if ((point.y > ((HEIGHT-19)*2/3)+19) && (!squares[0][2])) 	// Bottum Left Square
			squares[0][2] = player_turn++;
		else if	((point.y > ((HEIGHT-19)*1/3)+19) && 
			(point.y < ((HEIGHT-19)*2/3)+19) && (!squares[0][1]))		// Middle Left Square
			squares[0][1] = player_turn++;
		}	
	else if (point.x > (WIDTH*2/3)-2){			// Right Side of the Board
		if ((point.y < ((HEIGHT-19)*1/3)+19) && (!squares[2][0])) 		// Top Right Square
			squares[2][0] = player_turn++;
		else if ((point.y > ((HEIGHT-19)*2/3)+19) && (!squares[2][2]))	// Bottum Right Square
			squares[2][2] = player_turn++;
		else if((point.y > ((HEIGHT-19)*1/3)+19) &&
			(point.y < ((HEIGHT-19)*2/3)+19) && (!squares[2][1]))		// Middle Right Square
			squares[2][1] = player_turn++;
		}
	else {										// Middle of the Board
		if ((point.y < ((HEIGHT-19)*1/3)+19) && (!squares[1][0]))		// Top Middle Square
			squares[1][0] = player_turn++;
		else if ((point.y > ((HEIGHT-19)*2/3)+19) && (!squares[1][2]))	// Bottum Middle Square
			squares[1][2] = player_turn++;
		else if((point.y > ((HEIGHT-19)*1/3)+19) &&
			(point.y < ((HEIGHT-19)*2/3)+19) && (!squares[1][1]))		// Middle Middle Square
			squares[1][1] = player_turn++;
		};
	
	BRect temp;		
	Draw(temp);
	
	check_for_win();
	
	if (player_turn==3) player_turn=1;
	};
	}; // End of MouseDown

/*****
*  check_for_win
*****/	
void tview::check_for_win(){
	rgb_color tempColor;
	short xs, xw, ys, yw;
	
	xs = (WIDTH*1/6); 				xw = (WIDTH*2/6);
	ys = ((HEIGHT-19)*1/6)+20; 		yw = ((HEIGHT-19)*1/6)+20;
	
	tempColor.red 	= (uchar)0;
	tempColor.green = (uchar)0;
	tempColor.blue 	= (uchar)0;
	tempColor.alpha = (uchar)0;
	SetPenSize(4.0);
				
	for (int i=1;i<3;i++){
		for (int j=0;j<3;j++)
			if ((squares[j][0]==i)&&(squares[j][1]==i)&&(squares[j][2]==i)){
				BeginLineArray(1);
				AddLine(BPoint(xs + xw*j,25), BPoint(xs + xw*j,HEIGHT-7), tempColor);
				EndLineArray();
				game_over++;
				};
			
			for (int j=0;j<3;j++)
				if ((squares[0][j]==i)&&(squares[1][j]==i)&&(squares[2][j]==i)){
					BeginLineArray(1);
					AddLine(BPoint(7,ys + yw*j), BPoint(WIDTH-7,ys + yw*j), tempColor);
					EndLineArray();
					game_over++;
					};
			
			if ((squares[0][0]==i)&&(squares[1][1]==i)&&(squares[2][2]==i)){
				BeginLineArray(1);
				AddLine(BPoint(xs-5,ys-5), BPoint((xs + xw*2)+5,(ys + yw*2)+5), tempColor);
				EndLineArray();
				game_over++;
				};
		
			if ((squares[0][2]==i)&&(squares[1][1]==i)&&(squares[2][0]==i)){
				BeginLineArray(1);
				AddLine(BPoint(xs-5,(ys + yw*2)+5), BPoint((xs + xw*2)+5,ys-5), tempColor);
				EndLineArray();
				game_over++;
				};
			};
		}; // End of check_for_win
	
	
	