/*****
*
* twindow.cpp 
*
*****/

/*** includes ***/
#include "twindow.h"
#include "tview.h"
#include "const.h"

/*****
* constructor
*****/
twindow::twindow(BRect frame)
	: BWindow(frame, "TiC TaC tOe", B_TITLED_WINDOW, B_NOT_RESIZABLE){
	
	Lock();
	
	// Add View	
	frame.OffsetTo(B_ORIGIN);
	myView = new tview(frame, "myView");
	
	// add view to window
	AddChild(myView);
	
	// Add Menus
	//frame.bottum = 19;
	frame.Set(0, 0, WIDTH, 19);
	SetUpMenus(frame);
	myView->AddChild(menuBar);
	myView->SetViewColor(100,100,100);	
	
	Unlock();
	};

/*****
* destructor
*****/
twindow::~twindow(){
	
	};
	
/*****
* quit requested
*****/
bool twindow::QuitRequested(){
	be_app->PostMessage(B_QUIT_REQUESTED);
	return(TRUE);
	};

/*****
* SetUp Menus
*****/
void twindow::SetUpMenus(BRect bounds){
	BMenu		*play, *options;
	BMenuItem	*newItem;
	char		numString[8];
	BMessage	*msg;
	
	// create the menu bar
	menuBar = new BMenuBar(bounds, "menubar", B_FOLLOW_ALL, B_ITEMS_IN_ROW,
		FALSE);
		
	// create the "Play" and "Options" menus
	play = new BMenu("File", B_ITEMS_IN_COLUMN);
	options = new BMenu("Edit", B_ITEMS_IN_COLUMN);
	options->SetEnabled(FALSE);
		
	// add items to "File" menu
	newItem = new BMenuItem("New Game", new BMessage(mRESTART), 'N', NULL);
	play->AddItem(newItem);
	play->AddSeparatorItem();
	newItem = new BMenuItem("Exit", new BMessage(mQUIT), 'Q', NULL);
	play->AddItem(newItem);
	
	// add items to "Edit" menu
	newItem = new BMenuItem("Copy", new BMessage(mBOGUS), 'C', NULL);
	options->AddItem(newItem);
	newItem = new BMenuItem("Cut", new BMessage(mBOGUS), 'X', NULL);
	options->AddItem(newItem);
	options->AddSeparatorItem();
	newItem = new BMenuItem("Paste", new BMessage(mBOGUS), 'V', NULL);
	options->AddItem(newItem);
	
	// insert the two menus into the menu bar
	menuBar->AddItem(play);
	menuBar->AddItem(options);
	};
	
/*****
*  MessageReceived
*****/
void twindow::MessageReceived(BMessage *message){
	Lock();
	switch(message->what){
		case mQUIT:
			be_app->PostMessage(B_QUIT_REQUESTED);
			break;
		case mRESTART:
			{
			BRect temp;
			myView->reset_game();
			myView->Draw(temp);
			};
			break;
		case mBOGUS:
			break;
		};
	Unlock();
	};
